
                                                 (*:  --Ŀ
                  [http://www.royale.linux-fan.com]ͻ 
                  ĿĿĿĿĿ  Ŀ  |
                .                Ŀ          
                :                   Ĵ  :
                    ٳ   Ŀ ٳ    Ŀ      .
                |           
                 [1999][royale@ifrance.com]ͼ
                --  :*)

program NEW_ENTROPY;

uses crt,mode13,pcx,sourunit; (* CRT pour KEYPRESSED et READKEY *)

type Tpion=(Vide,Rouge,Vert,Orange,Bleu,Jaune,Blanc,Noir);
     Tgrille=array [1..7,1..7] of Tpion;
     Tgenre=(humain,ordinateur);
     Tjoueur=record
               nom:string[10];
               genre:Tgenre;
               score:word;
             end;
(* Utilis pour dfinir un couple de coordonnes sur la grille : *)
     Tposition=record x,y:byte; end;

const POS_VIDE:Tposition=(x:0;y:0);
(* Couple de coordonnes non valides utilises pour certaines sorties *)
      ATTENTE=70;
(* Attente de l'ordinateur en nombre de rafraichissements de l'cran.
   70Hz pour le Mode 13h *)

var sprt_pg,fond_pg,make_pg:pointer;
(* Pointeurs de pages virtuelles sur les sprites, le fond et la page de
   construction *)
    attaque:record (* Utilis pour dterminer les attaques possibles : *)
      nombre:byte;
      coup:array [1..13] of record
        position:Tposition;
        score:word;
      end;
    end;
    grille:Tgrille;          (* Grille principale du jeu *)
    joueur1,joueur2:Tjoueur; (* Les 2 joueurs *)
    Niveau_IA_Attaque,Niveau_IA_Defense:(facile,dur);
(* Les niveaux de l'ordinateur en attaque et dfense *)
    Aide:boolean;            (* L'option d'Aide *)

{$i attaques.inc}            (* Routine de tests d'attaque  *)
{$i score.inc}               (* Routine de calcul de score  *)
{$i RND.inc}                 (* Routines de jeu alatoires  *)
{$i IA.inc}                  (* Routines de jeu intelligent *)
{$i intro.inc}               (* Routine d'introduction      *)

procedure vider(var grille:Tgrille); (* Vide la grille ! *)
var i,j:byte;
begin
  for i:=1 to 7 do for j:=1 to 7 do grille[i,j]:=vide;
end;

procedure affiche(attaquant,defenseur:Tjoueur; Piece:Tpion; Position:Tposition);
(****************************************************************************)
(* Affiche la grille, le nom des joueurs, la pice pioche s'il y en a une  *)
(* ou encadre la dernire pice pose.                                      *)
(*  Piece=VIDE s'il n'y a pas de pice pioche (c'est  l'attaquant de     *)
(* jouer et la pice pioche est dj sur le tablier)                       *)
(* Piece<>VIDE s'il y a une pice pioche (c'est au dfenseur de la placer) *)
(*  Positon=POS_VIDE s'il n'y a pas de pice pose (c'est au dfenseur de  *)
(* jouer                                                                    *)
(* Positon<>POS_VIDE s'il y a une pice pose (c'est  l'attaquant de la    *)
(* dplacer)                                                                *)
(****************************************************************************)
var i,j:byte;
    s:string;
begin
(* Copier l'image de la grille dans la page de construction *)
  copypage(fond_pg,make_pg);
(* Si la position est valide, c'est  dire s'il y a une pice pose sur la
   grille, alors il faut l'encadrer *)
  with position do if x<>0 then begin
    for i:=(x-1)*28 to x*28 do begin
      putpixel(make_pg,i,(y-1)*28,185);
      putpixel(make_pg,i,y*28,185);
    end;
    for j:=(y-1)*28 to y*28 do begin
      putpixel(make_pg,(x-1)*28,j,185);
      putpixel(make_pg,x*28,j,185);
    end;
  end;
(* Affichage de la grille *)
  for j:=1 to 7 do
    for i:=1 to 7 do
      if grille[i,j]<>vide then
(* Copier les pions de la page des sprites vers la page construction
   Les pions sont ordonnes dans l'image source *)
        copyblock(25,25,sprt_pg,ord(grille[i,j])*25-25,0,
        make_pg,(i-1)*28+2,(j-1)*28+2,false);
(* Afficher l'estimation du score *)
  str(score(grille,false),s);
(* Afficher les noms des joueurs *)
  outtextxy(make_pg,255,67,S,155,92);
  outtextxy(make_pg,220,100,attaquant.nom,155,92);
  outtextxy(make_pg,220,135,defenseur.nom,155,92);
(* S'il y a une pice a poser, l'afficher *)
  if piece<>vide then copyblock(25,25,sprt_pg,(ord(piece)-1)*25,0,make_pg,255,152,true);
(* Attendre le passage du rayon cathodique pour viter les clignotements *)
  waitretrace;
(* Effacer la souris *)
  souris_off;
(* Afficher la page de construction  l'cran *)
  copypage(make_pg,scrn_pg);
(* Afficher la souris *)
  souris_on;
end;

function genre2string(Vgenre:Tgenre):string;
(* Convertir un Genre en la chaine de caractres correspondante *)
begin
  if Vgenre=humain then genre2string:='Humain'
                   else genre2string:='Ordinateur'
end;

function tablier:Tpion;
(* Piocher un pion alatoirement dans le sac *)
var i,j:byte;
    temp:Tpion;
    cmpt:byte;
begin
  repeat
    cmpt:=0;
(* Choisir un pion au hasard *)
    temp:=Tpion(random(7)+1);
(* Compter le nombre de pions de cette couleur dj placs sur la grille *)
    for i:=1 to 7 do for j:=1 to 7 do
      if grille[i,j]=temp then inc(cmpt);
(* Rpter ceci jusqu' ce que le pion choisi soit valide *)
  until cmpt<>7;
  tablier:=temp;
end;

function abandon:boolean;
(* Affiche une boite de dialogue invitant le joueur  abandonner
   Sortie : Vrai s'il a abandonn, Faux sinon *)
begin
  souris_off;
(* Copier la zone de l'cran qui va tre crase par la boite de dialogue *)
  copyblock(159,96,scrn_pg,20,40,make_pg,0,0,true);
(* Afficher la boite de dialogue *)
  copyblock(159,96,sprt_pg,0,25,scrn_pg,20,40,true);
  souris_on;
  repeat until souris_bout<>1;
(* Attendre que l'utilisateur appuie sur le bouton GAUCHE de la souris *)
  repeat until souris_bout=1;
(* Abandon<-Vrai si le joueur a cliqu sur le bouton "OUI" *)
  abandon:=(x_souris in [30..94]) and (y_souris in [102..126]);
  waitretrace;
  souris_off;
(* Restaurer l'cran *)
  copyblock(159,96,make_pg,0,0,scrn_pg,20,40,true);
  souris_on;
(* Attendre que l'utilisateur veuille bien relacher le bouton ! *)
  repeat until souris_bout<>1;
end;

procedure choisir(var position:Tposition);
(****************************************************************************)
(* Invite le joueur  choisir une case                                      *)
(* Il n'y a pas besoin de tests de validit car la souris est borne dans   *)
(* la zone de la grille donc le joueur ne peut que cliquer dessus !         *)
(* Toutefois, il faut lui donner la possibilit d'afficher le menu          *)
(* d'abandon. Pour cel, il n'a qu' presser sur le bouton DROIT.           *)
(****************************************************************************)
var ok:boolean;
begin
  ok:=false;
(* Attendre que tous les boutons soient relachs *)
  repeat until souris_bout=0;
(* Rpter jusqu' ce que l'utilisateur fasse un choix valide *)
  repeat
    if souris_bout=1 then begin
      position.x:=x_souris div 28+1;
      position.y:=y_souris div 28+1;
(* Cliquer sur une case vide est un choix valide *)
      if grille[position.x,position.y]=vide then ok:=true;
    end;
    if souris_bout=2 then if abandon then begin
(* Abandonner est un autre choix... Mais pour le distinguer on retourne une
   case non valide : POS_VIDE ! *)
      position:=pos_vide;
      ok:=true;
    end;
  until ok;
end;

function manche(var attaquant,defenseur:Tjoueur):boolean;
(****************************************************************************)
(* La routine centrale : ralise une manche entre deux joueurs.             *)
(* Sortie : Vrai si la partie s'est termine normalement.                   *)
(*          Faux si l'un des joueurs a abandonn.                           *)
(****************************************************************************)
var cmpt,i,j,tour:byte;
    opos,npos:Tposition;
    piece:Tpion;
    ok:boolean;
begin
  manche:=false;
(* Jouer 49 tours *)
  for tour:=1 to 7*7 do begin
(* Piocher une pice *)
    piece:=tablier;
(* Afficher la grille avec la pice pioche *)
    affiche(attaquant,defenseur,piece,pos_vide);
    if defenseur.genre=humain then begin
(* Si c'est un humain et qu'il a choisi l'AIDE, lui montrer les meilleurs
   coups *)
      if Aide=true then IA_defense(piece,opos,true);
(* Inviter le joueur a choisir une case *)
      choisir(opos);
(* Si la coordonne de retour n'est pas valide, c'est qu'il a abandonn *)
      if opos.x=0 then
(* Que faire si le joueur a abandonn ?
   Il n'y a pas de contre attaque et il faut sortir la boucle des tours.
   Cel entraine une succession de IF THEN ELSE IF THEN [...] imbriqus qui
   alourdissent considrablement le code. J'ai donc opt pour le EXIT qui
   permet d'viter cet inconvnient *)
        exit;
    end else begin
(* Si le joueur est un ordinateur, alors en fonction du niveau de dfense
   choisi, defendre au hasard ou intelligemment *)
      if Niveau_IA_Defense=facile then RND_defense(opos) else IA_defense(piece,opos,false);
(* Attendre que l'utilisateur voit le coup *)
      wdelay(ATTENTE);
    end;
(* Pour aider le joueur suivant  attaquer, il est interressant de placer la
   souris sur le pion ! *)
    souris_en_xy( (opos.x-1)*28+14,(opos.y-1)*28+14 );
(* Mettre le pion dans la grille *)
    grille[opos.x,opos.y]:=piece;
(* Ractualiser la grille avec le cadre autour de la pice pose *)
    affiche(attaquant,defenseur,vide,opos);
(* Enlever le pions de la grille car le joueur va le dplacer *)
    grille[opos.x,opos.y]:=vide;
(* Chercher toutes les attaques possibles  partir de la position 'opos' *)
    attaques(opos);
    ok:=false;
    if attaquant.genre=humain then begin
(* Si c'est un humain et qu'il a choisi l'AIDE, lui montrer les meilleurs
   coups *)
      if Aide=true then IA_attaque(piece,opos,true);
(* Rpter jusqu' ce que le choix soit valide *)
      repeat
        choisir(npos);
(* Ici, il faut sortir deux boucles si le joueur abandonne ce qui est
   galement lourd  implmenter d'o le choix du EXIT *)
        if npos.x=0 then exit;
(* Si le joueur a choisi une case, vrifier que le coup fait partie des
   attaques possibles *)
        for cmpt:=1 to attaque.nombre do
          if (attaque.coup[cmpt].position.x=npos.x)
         and (attaque.coup[cmpt].position.y=npos.y) then ok:=true;
      until ok;
   end else begin
(* Sinon, attaquer au hasard ou intelligemment selon le niveau choisi *)
      if Niveau_IA_attaque=facile then RND_attaque(npos) else IA_attaque(piece,npos,false);
      wdelay(ATTENTE);
    end;
    souris_en_xy( (npos.x-1)*28+14,(npos.y-1)*28+14 );
(* Placer le pion  ses nouvelles coordonnes *)
    grille[npos.x,npos.y]:=piece;
  end;
(* Afficher un dernire fois la grille sans pice pioche ni encadrement de
   case car plus personne ne peut jouer *)
  affiche(attaquant,defenseur,vide,pos_vide);
(* L'attaquant marque ses points *)
  attaquant.score:=score(grille,false);
(* Attendre que l'utilisateur clique *)
  repeat until souris_bout<>1;
  repeat until souris_bout=1;
(* Super, la manche s'est termine correctement ! *)
  manche:=true;
end;

procedure resultats;
(* Affiche les rsultats d'une partie  l'issue des 2 manches *)
var s:string;
begin
  souris_off;
(* Effacer l'cran *)
  clearpage(scrn_pg);
(* Nom du premier joueur et son score *)
  str(joueur1.score,s);
  outtextxy(scrn_pg,70,70,joueur1.nom+' : '+s,155,92);
(* Nom du second joueur et son score *)
  str(joueur2.score,s);
  outtextxy(scrn_pg,70,90,joueur2.nom+' : '+s,155,92);
(* Afficher le gagnant s'il y en a un *)
  if joueur1.score>joueur2.score then
    outtextxy(scrn_pg,70,115,'GAGNANT : '+joueur1.nom,155,92) else
  if joueur1.score<joueur2.score then
    outtextxy(scrn_pg,70,115,'GAGNANT : '+joueur2.nom,155,92) else
(* Sinon afficher qu'il s'agit d'un match nul *)
    outtextxy(scrn_pg,70,115,'MATCH NUL !',155,92);
(* Attendre que l'utilisateur clique *)
  souris_on;
  repeat until souris_bout<>1;
  repeat until souris_bout=1;
end;

procedure jouer;
(* Organise une partie de NEW ENTROPY entre le Joueur1 et le Joueur2 *)
begin
  fillchar(pal,768,0);
  setpal;
(* Vider la palette : elle est toute noire ! *)
  loadpcx('grille.pcx',fond_pg);
  loadpcx('sprite.pcx',sprt_pg);
(* Charger les 2 images au format PCX dans les diffrentes pages :
   Image de fond et image des sprites *)
  vider(grille);
(* Afficher une grille vide *)
  affiche(joueur1,joueur2,vide,pos_vide);
(* Fondu d'entre *)
  fade_in;
(* Si la premire manche s'est termine normalement, jouer la seconde *)
  if manche(joueur1,joueur2) then begin
    vider(grille);
(* Si la seconde manche s'est termine normalement, afficher les rsultats *)
    if manche(joueur2,joueur1) then resultats;
  end;
(* Fondu de sortie *)
  fade_out;
end;

{$i initclos.inc}            (* Routines d'initialisation et fermeture *)
{$i info.inc}                (* Routine du droulant d'informations    *)
{$i menu.inc}                (* Routines du menu de slection de jeu   *)

begin
  init;                 (* Initialiser tout *)
  intro;                (* Afficher l'intro *)
  menu;                 (* Lancer le menu   *)
  clos;                 (* Fermer tout      *)
end.