
                                                 (*:  --Ŀ
                  [http://www.royale.linux-fan.com]ͻ 
                  ĿĿĿĿĿ  Ŀ  |
                .                Ŀ          
                :                   Ĵ  :
                    ٳ   Ŀ ٳ    Ŀ      .
                |           
                 [1999][royale@ifrance.com]ͼ
                --  :*)

(* Unit Format PCX *)
unit pcx;

(*******************************) INTERFACE (********************************)

procedure loadpcx(name:string; page:pointer);


(****************************) IMPLEMENTATION (******************************)
uses mode13; (* Ce chargeur PCX ne fonctionne que pour le Mode 13h *)

procedure loadpcx(name:string; page:pointer);
(* Charge une image au format PCX contenue dans le fichier 'name' vers la
   page destination. L'image source est suppose tre au bon format :
   320x200 points, 256 couleurs. *)
const buffersize=1024; (* Taille du buffer disque *)
var
  numread,counter,k:word;
  buffer:array [1..buffersize] of byte; (* Buffer disque pour acclrer la lecture *)
  col,fois:byte; (* Couleur lue et nombre de rptitions de cette couleur *)
  offse:word;    (* Offset courant dans la page destination = 320*y+x *)
  pcxfile:file;  (* Fichier dans lequel se trouve l'image *)

begin
(* Ouvrir le fichier avec 1 octet comme taille d'enregistrement de base *)
  assign(pcxfile,name);
  reset(pcxfile,1);
  seek(pcxfile,filesize(pcxfile)-768); (* Aller 768 octets avant la fin *)
  blockread(pcxfile,pal,768);          (* Charger la palette *)
  seek(pcxfile,128);                   (* Sauter  la fin de l'en tte *)
  offse:=0;                            (* Commencer  l'offset 0 *)
(* Initialiser l'indice de buffer  une valeur trop grosse pour effectuer le
   premier chargement du buffer *)
  counter:=buffersize+1;
(* Tant que l'image n'est pas finie *)
  while (offse<320*200) do begin
(* Incrmenter la position de l'indice de buffer *)
    inc(counter);
    if counter>buffersize then begin
(* Si on a dpass le buffer courant, il faut charger la suite du fichier *)
      blockread(pcxfile,buffer,bufferSize,numread);
      counter:=1;
    end;
(* Si l'octet dans le buffer est suprieur  192, il s'agit d'une rptition ... *)
    if buffer[counter]>=192 then begin
      fois:=buffer[counter]-192; (* Isoler le facteur *)
      inc(counter);              (* Lire l'octet suivant dans le buffer *)
      if counter>buffersize then begin
          blockread(pcxfile,buffer,buffersize,numread);
          counter:=1;
        end;
        col:=buffer[counter];    (* La couleur qui se rpte *)
      end else begin
(* ... Sinon, il s'agit d'une couleur simple *)
      fois:=1;
      col:=buffer[counter];
    end;
(* Copier le nombre de points ncessaires dans la page *)
    for k:=1 to fois do begin
      mem[seg(page^):ofs(page^)+offse]:=col;
      offse:=offse+1;
    end;
  end;
  close(pcxfile); (* Fermer le fichier ! *)
end;

end.