
                                                 (*:  --Ŀ
                  [http://www.royale.linux-fan.com]ͻ 
                  ĿĿĿĿĿ  Ŀ  |
                .                Ŀ          
                :                   Ĵ  :
                    ٳ   Ŀ ٳ    Ŀ      .
                |           
                 [1999][royale@ifrance.com]ͼ
                --  :*)

(* Unit de gestion de la souris.
   Celle-ci convient pour le Mode 13h.
   En effet, la taille suppose de l'cran par dfaut dans le gestionnaire
   souris est 640x200. Comme l'cran graphique en Mode 13h est 320x200, il
   faut tenir compte du facteur 2 avec les coordonnes en x. Cette manipulation
   est intgre dans les routines *)
unit sourunit;

(*******************************) INTERFACE (********************************)

(* Dfinition des routines souris *)
function x_souris:word;
function y_souris:word;
function souris_bout:byte;
procedure init_souris;
procedure limit_souris(xmin,xmax,ymin,ymax:word);
procedure souris_on;
procedure souris_off;
procedure souris_en_xy(x,y:word);


(****************************) IMPLEMENTATION (******************************)

procedure init_souris; assembler;
(* Initialise le gestionnaire souris *)
asm
  mov ax,00h                 (* Fonction 0 : initialiser ! *)
  int 33h
end;

procedure limit_souris(xmin,xmax,ymin,ymax:word); assembler;
(* Dfini la zone graphique dans laquelle la souris peut se dplacer.
   Ceci permet de bloquer la souris dans un rectangle infrieur  l'cran.
   Ce rectangle est dfini par son coin suprieur gauche (xmin,ymin) et
   son coin infrieur droit (xmax,ymax) *)
asm
  mov ax,7                   (* Fonction 7 : dfinir la zone horizontale *)
  mov cx,xmin
  shl cx,1                   (* En fait, on veut Xmin*2 *)
  mov dx,xmax
  shl dx,1                   (* Ici aussi, on veut Xmax*2 *)
  int 33h                    (* Valider *)
  mov ax,8                   (* Fonction 8 : dfinir la zone verticale *)
  mov cx,ymin                (* Ymin *)
  mov dx,ymax                (* Ymax *)
  int 33h                    (* Valider *)
end;

procedure souris_on; assembler;
(* Affiche le curseur souris sur l'cran graphique. Le gestionnaire souris
   gre lui-mme la rsolution *)
asm
  mov ax,01h                 (* Fonction 1 : Afficher *)
  int 33h
end;

procedure souris_off; assembler;
(* Masquer le curseur souris sur l'cran *)
asm
  mov ax,02h                 (* Fonction 2 : Masquer *)
  int 33h
end;

procedure souris_en_xy(x,y:word); assembler;
(* Placer la souris aux coordonnes (x,y) de l'cran *)
asm
  mov ax,04h                 (* Fonction 4 : Dplacement du curseur *)
  mov cx,x
  shl cx,1                   (* On veut X*2 *)
  mov dx,y                   (* Y est juste *)
  int 33h                    (* Valider *)
end;

function x_souris:word; assembler;
(* Renvoie la coordonne X de la souris *)
asm
  mov ax,03h                 (* Fonction 3 : Coordonnes de la souris *)
  int 33h                    (* En sortie, cx <- X_souris *)
  shr cx,1                   (* En fait, on veut X_souris/2 *)
  mov ax,cx                  (* AX est le registe sur lequel on place le
                                rsultat de la fonction car c'est un mot *)
end;

function y_souris:word; assembler;
(* Renvoie la coordonne Y de la souris *)
asm
  mov ax,03h                 (* Fonction 3 : Coordonnes de la souris *)
  int 33h                    (* On a aussi : dx <- Y_souris *)
  mov ax,dx                  (* AX est le rsultat de la fonction *)
end;

function souris_bout:byte; assembler;
(* Renvoie l'tat des boutons de la souris :
     0 : aucun bouton.
     1 : bouton gauche appuy.
     2 : bouton droit appuy.
     3 : 2 boutons appuys. *)
asm
  mov ax,3                   (* La fonction 3 renvoie aussi l'tat des boutons *)
  int 33h                    (* En sortie, bl <- tat de boutons *)
  mov al,bl                  (* AL est le rsultat de la fonction *)
end;

end.